--local _loveframes = null

local _saveFrame  = null

local gui = {}
local BASE = (...):match("(.-)[^%.]+$")

local quickie = require( BASE.. "libs.quickie" )

local _showMenu = false


function gui.init( )
	--[[
	_loveframes = require("libs.loveframes")
	_saveFrame = _loveframes.Create("frame")
	
	
	_saveFrame:SetName("Text Input")
	_saveFrame:SetSize(500, 60)
			 
	local textinput = _loveframes.Create("textinput", _saveFrame)
	textinput:SetPos(5, 30)
	textinput:SetWidth(490)
	textinput.OnFocusGained = function(object)
		love.keyboard.setTextInput(true)
	end
	
	textinput.OnFocusLost = function(object)
		love.keyboard.setTextInput(false)
	end
	
	
	textinput.OnEnter = function(object)
			object:Clear()
			object:SetFocus( false )
	end
	
	textinput:SetFont(love.graphics.newFont(20))
	
	local button = _loveframes.Create("button")
  
	
	-- with method chaining
	button:SetText("New Button"):Center() :SetSize(200, 200)
 
	button.OnClick = function( object, x, y )
		print( "clicked!" )
	end
	--button:SetVisible( false )
]]

	quickie.group.default.size[1] = 300
  quickie.group.default.size[2] = 100
	quickie.group.default.spacing = 0

end

local _fileName = "drawing"
local istrue = false
local inputtext = {text = "" }
local _saving = false
local _loading = false
local _replaceSave = false
local _typing = false

function gui.draw() 
	--_loveframes.draw()
	
	quickie.core.draw()
end

function gui.update( dt ) 
	--_loveframes.update(dt)
	
	if( _showMenu ) then
		
	
		love.graphics.setFont( FONTS.big )
		
		
		quickie.group.push{grow = "down", 
			pos = { ( love.window.getWidth() - quickie.group.default.size[1] ) / 2, 
			( love.window.getHeight() - quickie.group.default.size[2] * 3 ) / 2 } }
		
		if quickie.Button{ text = "Save" } then
			_saving = true
			_showMenu = false
			inputtext.text = _fileName
			
		end
		if quickie.Button{ text = "Load" } then
			_loading = true
			_showMenu = false
			inputtext.text = _fileName
		end
		if quickie.Button{ text = "Exit" } then
			_showMenu = false
			love.event.quit() 
		end
		quickie.group.pop()
	end	
	if( _saving or _loading ) then
		love.graphics.setFont( FONTS.big )
		local pos = { ( love.window.getWidth() - quickie.group.default.size[1] ) / 2, 
			( love.window.getHeight() - quickie.group.default.size[2] * 2 ) / 2 } 

		
		if( love.keyboard.hasTextInput() and love.system.getOS() == "Android" ) then
			pos[2] = 0 
		end
		
		quickie.group.push{grow = "down", 	pos = pos }
		
		local text = "Save to file:"
		if( _loading ) then text = "Load file:" end
		quickie.Label{ text = text }
		if( quickie.Input{info = inputtext, size = {300}} ) then
			print("input clicked")
			love.keyboard.setTextInput(true)
			_typing = true
		end
		
		quickie.group.pop()
		
	end
	if( _replaceSave ) then
		love.graphics.setFont( FONTS.big )
		quickie.group.push{grow = "down", 
			pos = { ( love.window.getWidth() - quickie.group.default.size[1] ) / 2, 
			( love.window.getHeight() - quickie.group.default.size[2] * 3 ) / 2 } }
	
		quickie.Label{ text = text }
		quickie.group.push{ grow = "right" }
		if quickie.Button { text = "Ok" } then
			saveFile()
		end
		if quickie.Button { text = "Cancel" } then
			_replaceSave = false
		end
		quickie.group.pop()
		quickie.group.pop()
		
	end
	
	
end


function gui.keypressed( key, unicode )
	print( key )
	if key == "escape" then
		if _saving or _loading or _replaceSave then
			_saving = false
			_loading = false
			_replaceSave = false
			_typing = false
			return true;
		
		else
			_showMenu = not _showMenu
			return true;
		end
	elseif key == "backspace" and ( _loading or _saving ) then
		inputtext.text = inputtext.text:sub(1, -2)
	elseif key == "return" or key == "kpenter" then
		
		if  _saving and inputtext.text ~= "" then
			_fileName = inputtext.text
			if( love.filesystem.exists( _fileName ) ) then
				_replaceSave = true
				_typing = false
				
			else
				_typing = false
				saveFile( inputtext.text )
			end
			_saving = false
		return true;
		
		elseif  _loading and inputtext.text ~= "" then
			_fileName = inputtext.text
			loadFile( inputtext.text )
			_loading = false
			
			_typing = false
		return true;
	
		elseif _saving or _loading then return true
		end

	elseif _saving or _loading then return true 
	end
	
	
	
	return false;
	

	
	--_loveframes.keypressed( key, unicode )
	

end

function gui.keyreleased( key )
	--_loveframes.keyreleased( key )
end

function gui.mousepressed( x, y, button )
	--_loveframes.mousepressed(x , y, button )
end

function gui.mousereleased( x, y, button )
	--_loveframes.mousereleased( x, y, button )
end

function gui.textinput(text)
	--_loveframes.textinput(text)
	quickie.keyboard.textinput(text)
end

function gui.showInput()
	--_saveFrame.setVisible()
end


return gui
